<?php
class AutoDiscountCart extends Module
{
	public function __construct()
	{
		$this->name = 'autodiscountcart';
		$this->tab = 'Tools';
		$this->version = 1.2;

		parent::__construct();

		$this->displayName = $this->l('Cart - Discount insert automatically.');
		$this->description = $this->l('Enable the automatic insertion of coupons in cart.');
	}

	public function install()
	{
		if(!parent::install() || 
		   !$this->registerHook('cart') || 
		   !Configuration::updateValue('MOD_AUTOCART_ACTIVE', '') || 
		   !Configuration::updateValue('MOD_AUTOCART_TYPE', '3'))
			return false;
		else
			return true;
	}

	public function uninstall()
	{
		if(!parent::uninstall() || 
		   !Configuration::deleteByName('MOD_AUTOCART_ACTIVE') || 
		   !Configuration::deleteByName('MOD_AUTOCART_TYPE'))
		  return false;
		return true;
	}
	
	/**
	* Check discount validity
	*
	* @return mixed Return a string if an error occurred and false otherwise
	*/
	static public function getCustomerListDiscount($dateDay, $idCustomer) {
		switch(Configuration::get('MOD_AUTOCART_TYPE')*1) {
			case 1 :
				if(Configuration::get('MOD_TOOLSDISCOUNT_ACTIVE'))
					return Db::getInstance()->ExecuteS('
					SELECT tb.id_discount, tb.name 
					FROM '._DB_PREFIX_.'discount tb LEFT JOIN '._DB_PREFIX_.'customers_discount_affect tbl ON (tb.id_discount=tbl.id_discount) WHERE `date_from`<="'.$dateDay.'" AND `date_to`>="'.$dateDay.'" AND `active`=1 AND `id_customer`='.$idCustomer.' AND ISNULL(tbl.id_discount) ORDER BY date_to ASC' );
				else
					return Db::getInstance()->ExecuteS('
					SELECT id_discount, name 
					FROM '._DB_PREFIX_.'discount WHERE `date_from`<="'.$dateDay.'" AND `date_to`>="'.$dateDay.'" AND `active`=1 AND `id_customer`='.$idCustomer.' ORDER BY date_to ASC' );
			break;
			case 2 :
				return Db::getInstance()->ExecuteS('
				SELECT tb.id_discount, tb.name 
				FROM '._DB_PREFIX_.'discount tb INNER JOIN '._DB_PREFIX_.'customers_discount_affect tbl ON (tb.id_discount=tbl.id_discount) WHERE `date_from`<="'.$dateDay.'" AND `date_to`>="'.$dateDay.'" AND `active`=1 AND `id_customer`='.$idCustomer.' ORDER BY date_to ASC' );
			break;
			case 3 :
				return Db::getInstance()->ExecuteS('
				SELECT tb.id_discount, tb.name 
				FROM '._DB_PREFIX_.'discount tb WHERE `date_from`<="'.$dateDay.'" AND `date_to`>="'.$dateDay.'" AND `active`=1 AND `id_customer`='.$idCustomer.' ORDER BY date_to ASC' );
			break;
		}
	}
	
	public function getDiscountInCart() {
		global $cookie;
		return 	$result = Db::getInstance()->ExecuteS('
		SELECT d.*, `id_cart`
		FROM `'._DB_PREFIX_.'cart_discount` c
		LEFT JOIN `'._DB_PREFIX_.'discount` d ON c.`id_discount` = d.`id_discount`
		WHERE `id_cart` = '.intval($cookie->id_cart));

	}		

	function getContent()
	{
		if (Tools::isSubmit('submitAutoCart'))
		{
			$nbr = intval(Tools::getValue('nbr'));
			Configuration::updateValue('MOD_AUTOCART_ACTIVE', Tools::getValue('active_autocart'));
			Configuration::updateValue('MOD_AUTOCART_TYPE', Tools::getValue('DiscountTypeTarget'));
			if (isset($errors) AND sizeof($errors))
				$output .= $this->displayError(implode('<br />', $errors));
			else
				$output .= $this->displayConfirmation($this->l('Settings updated'));
		}
		return $output.$this->displayForm();
	}
	
	private function displayForm()
	{
		$output = '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset><legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				<label>'.$this->l('Enable').'</label>
				<div class="margin-form">
					<input type="checkbox" name="active_autocart" '.(Tools::getValue('active_autocart', Configuration::get('MOD_AUTOCART_ACTIVE')=='on') ? "checked" : "").'" />&nbsp;<span class="clear">'.$this->l('Add discount automatically.').'</span>
				</div>	
				<label>'.$this->l('Discount type').'</label>
				<div class="margin-form">
			<select name="DiscountTypeTarget">
				<option value="1"'.((Configuration::get('MOD_AUTOCART_TYPE'))=="1" ? ' selected': '').'>&nbsp;'.$this->l('Classics discounts').'&nbsp;</option>';
				if(Configuration::get('MOD_TOOLSDISCOUNT_ACTIVE')) 
				$output .= '<option value="2"'.((Configuration::get('MOD_AUTOCART_TYPE'))=="2" ? ' selected': '').'>&nbsp;'.$this->l('Automatic discounts').'&nbsp;</option>
				<option value="3"'.((Configuration::get('MOD_AUTOCART_TYPE'))=="3" ? ' selected': '').'>&nbsp;'.$this->l('Both').'&nbsp;</option>';
				
			$output .='</select>
				</div>	
				<center><input type="submit" name="submitAutoCart" value="'.$this->l('Save').'" class="button" /></center>
			</fieldset>
		</form>';
		return $output;
	}
	
	function hookCart($params)
	{
		if(Configuration::get('MOD_AUTOCART_ACTIVE')=='on') {
			global $cookie, $cart, $smarty;
			$ListDiscountAvailables = array();
			$ListDiscountAvailables = $this->getCustomerListDiscount(date('Y-m-d H:i:s'), intval($cookie->id_customer));
			if(count($ListDiscountAvailables)>0) {
				foreach($ListDiscountAvailables as $KeyDiscount=>$ValDiscount) {
					$errors = array();
					$DiscountId 	= $ValDiscount['id_discount'];
					$DiscountCode 	= $ValDiscount['name'];
					
					if (!$cart->checkQuantities()) {
						$errors[] = 'An item in your cart is no longer available, you cannot proceed with your order';
						Db::getInstance()->Execute('
						DELETE FROM '._DB_PREFIX_.'cart_discount WHERE id_discount='.$DiscountId);
					}
					$orderTotalDefaultCurrency = Tools::convertPrice($cart->getOrderTotal(true, 1), Currency::getCurrency(intval(Configuration::get('PS_CURRENCY_DEFAULT'))));
					$minimalPurchase = floatval(Configuration::get('PS_PURCHASE_MINIMUM'));
					
					if ($orderTotalDefaultCurrency < $minimalPurchase) {
						$errors[] = 'A minimum purchase total of '.Tools::displayPrice($minimalPurchase, Currency::getCurrency(intval($cart->id_currency))).' '.'is required in order to validate your order';
						Db::getInstance()->Execute('
						DELETE FROM '._DB_PREFIX_.'cart_discount WHERE id_discount='.$DiscountId);
					}
					
					if ($cart->nbProducts()) {
						if (!Validate::isDiscountName($DiscountCode)) {
							$errors[] = 'voucher name not valid';
						}
						else
						{
							$TabDiscountsActives = array();
							$ListDiscountCartActive = $this->getDiscountInCart();
							foreach($ListDiscountCartActive as $KeyDiscount=>$ValDiscount)	
								$TabDiscountsActives[$ValDiscount['id_discount']] = $ValDiscount['id_discount'];
							if(!in_array($DiscountId, $TabDiscountsActives)) {
							$discount = new Discount(intval($DiscountId));
								if (is_object($discount) AND $discount->id)
								{
									if ($tmpError = $cart->checkDiscountValidity($discount, $this->getDiscountInCart(), $cart->getOrderTotal(), $cart->getProducts(), true))
										$errors[] = $tmpError;
								}
								else {
									$errors[] = 'voucher name not valid';
								}
							}
							else {
								$errors[] = 'voucher name already active';
							}
						}
					}
					else {
						$errors[] = 'no product in cart';
						Db::getInstance()->Execute('
						DELETE FROM '._DB_PREFIX_.'cart_discount WHERE id_discount='.$DiscountId);
					}
					if (!sizeof($errors)) {
						$cart->addDiscount($DiscountId);
					}
				}	
			}
		}
	}
}

?>