<?php
include _PS_MODULE_DIR_.'blockmenulavalamp/menulavalamplinks.class.php';
class blockmenulavalamp extends Module
{
  private $_menu = '';
  private $_html = '';

  public function __construct()
  {
    $this->name = 'blockmenulavalamp';
    $this->tab = 'Blocks';
    $this->version = 1.2;
    parent::__construct();
    $this->displayName = $this->l('Top horizontal lavalamp menu');
    $this->description = $this->l('Add a new menu on top of your shop (lavalamp style).');
  }

  public function install()
  {
    if(!parent::install() || 
       !$this->registerHook('top') || 
       !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ITEMS', 'CAT1,CMS1,CMS2,PRD1') || 
       !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SEARCH', '1') || 
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_STYLE', '1') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_COULEUR', '00ff00') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ENCADRE', '1') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_HOVER', '00ff00') || 
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_TEXTE', 'FFFFFF') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_FOND', 'FFFFFF') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_GRAS', 'on') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ITALIC', '') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SOULI', '') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SGRAS', 'on') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SITALIC', '') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SSOULI', '') ||
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_POLICE', '14') ||	 
	   !Configuration::updateValue('MOD_BLOCKMENULAVALAMP_LANG', 'on') ||  
       !$this->installDB())
      return false;
    return true;
  }

  public function installDb()
  {
    Db::getInstance()->ExecuteS('
    CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'linksmenulavalamp` (
      `id_link` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY ,
      `new_window` TINYINT( 1 ) NOT NULL,
      `link` VARCHAR( 128 ) NOT NULL
    ) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci;');
    Db::getInstance()->ExecuteS('
    CREATE TABLE IF NOT EXISTS `'._DB_PREFIX_.'linksmenulavalamp_lang` (
    `id_link` INT NOT NULL ,
    `id_lang` INT NOT NULL ,
    `label` VARCHAR( 128 ) NOT NULL ,
    INDEX ( `id_link` , `id_lang` )
    ) ENGINE = MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci;');
    return true;
  }

  public function uninstall()
  {
    if(!parent::uninstall() || 
       !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_ITEMS') || 
       !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_SEARCH') || 
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_STYLE') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_COULEUR') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_ENCADRE') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_HOVER') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_TEXTE') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_FOND') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_GRAS') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_ITALIC') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_SOULI') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_SGRAS') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_SITALIC') ||
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_SSOULI') ||	   
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_POLICE') ||	
	   !Configuration::deleteByName('MOD_BLOCKMENULAVALAMP_LANG') ||
       !$this->uninstallDB())
      return false;
    return true;
  }

  private function uninstallDb()
  {
    Db::getInstance()->ExecuteS('DROP TABLE `'._DB_PREFIX_.'linksmenulavalamp`');
    Db::getInstance()->ExecuteS('DROP TABLE `'._DB_PREFIX_.'linksmenulavalamp_lang`');
    return true;
  }

  public function getContent()
  {
    global $cookie;
	$this->_html .='
		<link rel="stylesheet" href="../modules/blockmenulavalamp/css/colorpicker.css" type="text/css" />
		<link rel="stylesheet" href="../modules/blockmenulavalamp/css/layout.css" type="text/css"/>
		<script type="text/javascript" src="../modules/blockmenulavalamp/js/colorpicker.js"></script>
		<script type="text/javascript" src="../modules/blockmenulavalamp/js/eye.js"></script>
		<script type="text/javascript" src="../modules/blockmenulavalamp/js/utils.js"></script>
		<script type="text/javascript" src="../modules/blockmenulavalamp/js/layout.js?ver=1.0.2"></script>
	';
    if(Tools::isSubmit('submitblockmenulavalamp'))
    {
      if(Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ITEMS', Tools::getValue('items'))) {
		$this->_html .= $this->displayConfirmation($this->l('Settings Updated'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SEARCH', (bool)Tools::getValue('search'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_STYLE', Tools::getValue('lestyle'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_COULEUR', Tools::getValue('couleur'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ENCADRE', Tools::getValue('encadre'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_HOVER', Tools::getValue('couleur_hover'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_TEXTE', Tools::getValue('couleur_texte'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_FOND', Tools::getValue('couleur_fond'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_GRAS', Tools::getValue('texte_gras'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ITALIC', Tools::getValue('texte_italic'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SOULI', Tools::getValue('texte_souligne'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SGRAS', Tools::getValue('texte_gras_survol'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SITALIC', Tools::getValue('texte_italic_survol'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_SSOULI', Tools::getValue('texte_souligne_survol'));	  
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_POLICE', Tools::getValue('police_texte'));
		Configuration::updateValue('MOD_BLOCKMENULAVALAMP_LANG', Tools::getValue('langue'));
	  }
      else
        $this->_html .= $this->displayError($this->l('Unable to update settings'));
    }
    if(Tools::isSubmit('submitblockmenulavalampLinks'))
    {
      if(Tools::getValue('link') == '')
      {
        $this->_html .= $this->displayError($this->l('Unable to add this link'));
      }
      else
      {
        menulavalampLinks::add(Tools::getValue('link'), Tools::getValue('label'), Tools::getValue('new_window', 0));
        $this->_html .= $this->displayConfirmation($this->l('The link has been added'));
      }
    }
	//---- Ajout d'image
	if ( isset($_POST['submitUpdate']) ){
		if ( isset($_FILES['NewImage']['name']) ) {
			$img = dirname(__FILE__).'/images/'.$_FILES['NewImage']['name'];
			if ( !move_uploaded_file( $_FILES['NewImage']['tmp_name'], $img ) ){
				$this->_html .= $this->displayError($this->l('Error while upload picture'));
			}
		}
	}	
	//---- Suppression image
	if ( isset($_GET['action']) ){
		switch ( $_GET['action'] ){
		case 'SupprimeImage':
			echo 'reponse=>';
			unlink(dirname(__FILE__).'/images/'.$_GET['imageToSuppr']);
			exit; break;
		}
	}

    if(Tools::isSubmit('submitblockmenulavalampRemove'))
    {
      $id_link = Tools::getValue('id_link', 0);
      menulavalampLinks::remove($id_link);
      Configuration::updateValue('MOD_BLOCKMENULAVALAMP_ITEMS', str_replace(array('LNK'.$id_link.',', 'LNK'.$id_link), '', Configuration::get('MOD_BLOCKMENULAVALAMP_ITEMS')));
      $this->_html .= $this->displayConfirmation($this->l('The link has been removed'));
    }
    $this->_html .= '
    <fieldset>
      <legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Ustawienia').'</legend>
      <form action="'.$_SERVER['REQUEST_URI'].'" method="post" id="form">
		<div style="display: none">
			<label style="margin-top : -6px">'.$this->l('Items').'</label>
			<div class="margin-form">
				<input type="text" name="items" id="itemsInput" value="'.Configuration::get('MOD_BLOCKMENULAVALAMP_ITEMS').'" size="70" />
			</div>
		</div>

        <div class="clear">&nbsp;</div>
        <table style="margin-left: 130px;">
          <tbody>
            <tr>
              <td style="padding-left: 20px;" align="center">
			  	<b>'.$this->l('Dostępne menu').'</b><BR />
                <select multiple="multiple" id="availableItems" style="width: 300px; height: 160px;">';
                // BEGIN CMS
                $this->_html .= '<optgroup label="'.$this->l('CMS').'">';
                $_cms = CMS::listCms($cookie->id_lang);
                foreach($_cms as $cms)
                  $this->_html .= '<option value="CMS'.$cms['id_cms'].'" style="margin-left:10px;">'.$cms['meta_title'].'</option>';
                $this->_html .= '</optgroup>';
                // END CMS
                // BEGIN SUPPLIER
                $this->_html .= '<optgroup label="'.$this->l('Supplier').'">';
                $suppliers = Supplier::getSuppliers(false, $cookie->id_lang);
                foreach($suppliers as $supplier)
                  $this->_html .= '<option value="SUP'.$supplier['id_supplier'].'" style="margin-left:10px;">'.$supplier['name'].'</option>';
                $this->_html .= '</optgroup>';
                // END SUPPLIER
                // BEGIN Manufacturer
                $this->_html .= '<optgroup label="'.$this->l('Manufacturer').'">';
                $manufacturers = Manufacturer::getManufacturers(false, $cookie->id_lang);
                foreach($manufacturers as $manufacturer)
                  $this->_html .= '<option value="MAN'.$manufacturer['id_manufacturer'].'" style="margin-left:10px;">'.$manufacturer['name'].'</option>';
                $this->_html .= '</optgroup>';
                // END Manufacturer
                // BEGIN Categories
                $this->_html .= '<optgroup label="'.$this->l('Categories').'">';
                $this->getCategoryOption(1, $cookie->id_lang);
                $this->_html .= '</optgroup>';
                // END Categories
                // BEGIN Products
                $this->_html .= '<optgroup label="'.$this->l('Products').'">';
                  $this->_html .= '<option value="PRODUCT" style="margin-left:10px;font-style:italic">'.$this->l('Choose ID product').'</option>';
                $this->_html .= '</optgroup>';
                // END Products
                // BEGIN Menu Top Links
                $this->_html .= '<optgroup label="'.$this->l('Menu Top Links').'">';
                $links = menulavalampLinks::gets($cookie->id_lang);
                foreach($links as $link)
                  $this->_html .= '<option value="LNK'.$link['id_link'].'" style="margin-left:10px;">'.$link['label'].'</option>';
                $this->_html .= '</optgroup>';
                // END Menu Top Links
                $this->_html .= '</select><br />
                <br />
                <a href="#" id="addItem" style="border: 1px solid rgb(170, 170, 170); margin: 2px; padding: 2px; text-align: center; display: block; text-decoration: none; background-color: rgb(250, 250, 250); color: rgb(18, 52, 86);">'.$this->l('Dodaj').' &gt;&gt;</a>			
              <td align="center">
			  <b>'.$this->l('Wybrane menu').'</b><BR />
				        <select multiple="multiple" id="items" style="width: 300px; height: 160px;">';
                $this->makeMenuOption();
                $this->_html .= '</select><br/>
                <br/>
				        <a href="#" id="removeItem" style="border: 1px solid rgb(170, 170, 170); margin: 2px; padding: 2px; text-align: center; display: block; text-decoration: none; background-color: rgb(250, 250, 250); color: rgb(18, 52, 86);">&lt;&lt; '.$this->l('Usuń').'</a>
              </td>
              </td>
            </tr>
          </tbody>
        </table>
        <div class="clear">&nbsp;</div>
        <script type="text/javascript">
        $(document).ready(function(){
          $("#addItem").click(add);
          $("#availableItems").dblclick(add);
          $("#removeItem").click(remove);
          $("#items").dblclick(remove);
          function add()
          {
            $("#availableItems option:selected").each(function(i){
              var val = $(this).val();
              var text = $(this).text();
              if(val == "PRODUCT")
              {
                val = prompt("'.$this->l('Set ID product').'");
                if(val == null || val == "" || isNaN(val))
                  return;
                text = "'.$this->l('Product ID').' "+val;
                val = "PRD"+val;
              }
              $("#items").append("<option value=\""+val+"\">"+text+"</option>");
            });
            serialize();
            return false;
          }
          function remove()
          {
            $("#items option:selected").each(function(i){
              $(this).remove();
            });
            serialize();
            return false;
          }
          function serialize()
          {
            var options = "";
            $("#items option").each(function(i){
              options += $(this).val()+",";
            });
            $("#itemsInput").val(options.substr(0, options.length - 1));
          }
        });
        </script>
        <label style="margin-top : -6px">'.$this->l('Wyszukiwanie').'</label>
	    <div class="margin-form">
          <input type="checkbox" name="search" id="s" '.((Configuration::get('MOD_BLOCKMENULAVALAMP_SEARCH')==1) ? ' checked=""': '').'/>
        </div>
        <label style="margin-top : -6px">'.$this->l('Wybór języka').'</label>
	    <div class="margin-form">
          <input type="checkbox" name="langue" '.((Configuration::get('MOD_BLOCKMENULAVALAMP_LANG')=='on') ? ' checked=""': '').'/>
        </div>
		<label style="margin-top : -6px">'.$this->l('Opcje wyświetlania').'</label>
		<div class="margin-form">
			<table cellpadding="0" cellspacing="0" boder="0 width="100%">
			<TR><TD width="100">
					<input type="radio" name="lestyle" value="1"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_STYLE'))=="1" ? ' checked=""': '').'>&nbsp;&nbsp;'.$this->l('Z obrazkami').'<BR />
				</TD>
				<TD width="100">
					<input type="radio" name="lestyle" value="2"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_STYLE'))=="2" ? ' checked=""': '').'>&nbsp;&nbsp;'.$this->l('Bez obrazków').'<BR />
				</TD>
				<TD width="100">
					<input type="radio" name="lestyle" value="3"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_STYLE'))=="3" ? ' checked=""': '').'>&nbsp;&nbsp;'.$this->l('Podkreślone').'<BR />
				</TD>
			</TR></TABLE>
			<table cellpadding="0" cellspacing="0" boder="0 width="100%">
			<TR><TD width="100">'.$this->l('Podkreślone').'&nbsp;</TD><TD width="70"><b>'.$this->l('Kolor').'&nbsp;</b></TD>
				<TD width="50">
					<input type="hidden" name="couleur" value="'.Configuration::get('MOD_BLOCKMENULAVALAMP_COULEUR').'" id="HiddenColor2">
					<div id="customWidget">
						<div id="colorSelector2"><div style="background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_COULEUR').'"></div></div>
						<div id="colorpickerHolder2" style="z-index : 1000">
						</div>
					</div>
				</TD>
			</TR>
			<TR><TD width="100">'.$this->l('Tekst').'&nbsp;</TD><TD width="70"><b>'.$this->l('Kolor').'&nbsp;</b></TD>
				<TD width="50">
					<input type="hidden" name="couleur_texte" value="'.Configuration::get('MOD_BLOCKMENULAVALAMP_TEXTE').'" id="HiddenColor5">
					<div id="customWidget">
						<div id="colorSelector5"><div style="background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_TEXTE').'"></div></div>
						<div id="colorpickerHolder5" style="z-index : 1001">
						</div>
					</div>
				</TD>
				<TD align="center" width="70"><b>'.$this->l('Pogrubiony').'</b></TD><TD><input type="checkbox" name="texte_gras"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_GRAS'))=="on" ? ' checked=""': '').'></TD>
				<TD align="center" width="70"><b>'.$this->l('Pochylony').'</b></TD><TD><input type="checkbox" name="texte_italic"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_ITALIC'))=="on" ? ' checked=""': '').'></TD>
				<TD align="center" width="70"><b>'.$this->l('Podkreślony').'</b></TD><TD><input type="checkbox" name="texte_souligne"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SOULI'))=="on" ? ' checked=""': '').'></TD>
				<TD align="center" width="70"><b>'.$this->l('Rozmiar czcionki').'</b></TD><TD>
					<select name="police_texte">';
				for($i=10; $i<=20; $i=$i+2)
					$this->_html .= '<option value="'.$i.'" '.((Configuration::get('MOD_BLOCKMENULAVALAMP_POLICE'))==$i ? ' selected': '').'>&nbsp;'.$i.'&nbsp;</option>&nbsp;px';
			$this->_html .='</select>&nbsp;px
				</TD>
			</TR>
			<TR><TD width="100">'.$this->l('Po najechaniu').'&nbsp;</TD><TD width="70"><b>'.$this->l('Kolor').'&nbsp;</b></TD>
				<TD width="50">
					<input type="hidden" name="couleur_hover" value="'.Configuration::get('MOD_BLOCKMENULAVALAMP_HOVER').'" id="HiddenColor3">
					<div id="customWidget3">
						<div id="colorSelector3"><div style="background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_HOVER').'"></div></div>
						<div id="colorpickerHolder3" style="z-index : 1002">
						</div>
					</div>
				</TD>
				<TD align="center" width="70"><b>'.$this->l('Pogrubiony').'</b></TD><TD><input type="checkbox" name="texte_gras_survol"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SGRAS'))=="on" ? ' checked=""': '').'></TD>
				<TD align="center" width="70"><b>'.$this->l('Pochylony').'</b></TD><TD><input type="checkbox" name="texte_italic_survol"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SITALIC'))=="on" ? ' checked=""': '').'></TD>
				<TD align="center" width="70"><b>'.$this->l('Podkreślony').'</b></TD><TD><input type="checkbox" name="texte_souligne_survol"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SSOULI'))=="on" ? ' checked=""': '').'></TD>
			</TR>
			<TR><TD width="100">'.$this->l('Tło').'&nbsp;</TD><TD width="70"><b>'.$this->l('Kolor').'&nbsp;</b></TD>
				<TD width="50">
					<input type="hidden" name="couleur_fond" value="'.Configuration::get('MOD_BLOCKMENULAVALAMP_FOND').'" id="HiddenColor4">
					<div id="customWidget4">
						<div id="colorSelector4"><div style="background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_FOND').'"></div></div>
						<div id="colorpickerHolder4" style="z-index : 1003">
						</div>
					</div>
				</TD>
			</TR>
			</table>
		</div>        
		<label style="margin-top : -3px">'.$this->l('Ramka').'</label>
		<div class="margin-form">
			<select name="encadre">
				<option value="1"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_ENCADRE'))=="1" ? ' selected': '').'>&nbsp;'.$this->l('Tak').'&nbsp;</option>
				<option value="0"'.((Configuration::get('MOD_BLOCKMENULAVALAMP_ENCADRE'))=="0" ? ' selected': '').'>&nbsp;'.$this->l('Nie').'&nbsp;</option>
			</select>&nbsp;<i>'.$this->l('(Just for "With images" and "Underline")').'</i>
		</div>        
		<p class="center">
          <input type="submit" name="submitblockmenulavalamp" value="'.$this->l('  Zapisz  ').'" class="button" />
        </p>
      </form>
    </fieldset><br />
	';
	$tab_images_module = array('lava.gif', 'bg.gif');
	$images = glob('../modules/'.$this->name.'/images/*.gif');
	$this->_html .= '
		<fieldset>
			<legend><img src="'.$this->_path.'/images/fileAdd.gif" alt="" title="" />'.$this->l('Tryb obrazka').'</legend>
			<form action="'.$_SERVER['REQUEST_URI'].'" method="post" enctype="multipart/form-data" style="display:inline" onSubmit="return VerifImage()">
			<table border="0" width="100%">
				<tr>
					<td width="560" style="padding-left:3px;padding-top:5px">
							<input type="file" id="NewImage" name="NewImage" style="font-size:10px" size="116"/>
					</td>
					<TD>
						<input type="submit" class="button" value="'.$this->l('Wyślij').'" name="submitUpdate"/>
					</td>
				</tr>
	';
	if ( count($images)!=0 ) {
		foreach ( $images as $image ) {
			if(in_array(basename($image), $tab_images_module)) {
				if(basename($image) == 'bg.gif') {
					$this->_html .= '
						<tr>
							<td style="padding-top:5px" colspan="2">&nbsp;<b>'.$this->l('Tło menu (bg.gif)').'</b></td>
						</tr>
					';
				}
				if(basename($image) == 'lava.gif') {
					$this->_html .= '
						<tr>
							<td style="padding-top:5px" colspan="2">&nbsp;<b>'.$this->l('Klawisz menu (lava.gif)').'</b></td>
						</tr>
					';
				}
				
				$this->_html .= '
					<tr>
						<td width="560" style="padding-top:5px"><img src="'.$image.'" style="max-width: 560px" /></td>
						<td>
							<img src="'.$this->_path.'/images/fileSuppr.gif" align="absmiddle" style="margin-right:5px" /><a href="#" onclick="SupprimeImage(\''.basename($image).'\')">'.$this->l('Usuń zdjęcie').'</a>
						</td>
					</tr>
				';
			}
		}
	}
	$this->_html .= '
			<tr>
				<td colspan="2" style="padding-left:3px;padding-top:20px">
					<b>'.$this->l('Przykład').'&nbsp;:&nbsp;</b><a href="'.$this->_path.'/exemple.zip" style="color:#005DAF;"><img src="'.$this->_path.'/images/zipfile.png" alt="" title="" /></a>
				</td>
			</tr>
		</table>
	';
	$this->_html .= '					
			</form>
			<iframe id="slidehome_iframe" width="0" height="0" frameborder="0"></iframe>
			<script>
				MontreAjoutImage = function () {
					$("#AjoutImage").slideToggle("fast");
				}
				SupprimeImage = function (Photo) {
					if ( confirm("'.$this->l('Czy chcesz usunąć to zdjęcie ?').'") )
					$.ajax({
						type: "GET",
						url: "'.$_SERVER['REQUEST_URI'].'",
						data: "action=SupprimeImage&imageToSuppr="+Photo,
						success: function(reponse){
							reponse = reponse.split("reponse=>");
							reponse = reponse[1];
							window.location.replace("'.$_SERVER['REQUEST_URI'].'");
						}
					});
				}
				VerifImage = function () {
					var Photo = $("#NewImage").val();
					var ExtOK = Array(".jpg", "jpeg", ".bmp", ".png", ".gif");
					var Ext = Photo.substr(Photo.length-4,4);
					if ( Photo == "" ) {
						alert("'.$this->l('Proszę zaznaczyć plik zdjęcia.').'");
					} else if ( jQuery.inArray( Ext, ExtOK)==-1 ) {
						alert("'.$this->l('Plik zdjęcia The image file is not an approved format.').'");
						return false;
					} else {
						return true;
					}
				}
			</script>
			</fieldset><br />
	';
	$defaultLanguage = intval(Configuration::get('PS_LANG_DEFAULT'));
	$languages = Language::getLanguages();
	$iso = Language::getIsoById($defaultLanguage);
	$divLangName = 'link_label';
    $this->_html .= '
    <fieldset>
      <legend><img src="../img/admin/add.gif" alt="" title="" />'.$this->l('Add Menu Top Link').'</legend>
      <form action="'.$_SERVER['REQUEST_URI'].'" method="post" id="form">
  			<label style="margin-top : -3px">'.$this->l('Label').'</label>
        <div class="margin-form">';
				foreach ($languages as $language)
				{
					$this->_html .= '
					<div id="link_label_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
						<input type="text" name="label['.$language['id_lang'].']" id="label_'.$language['id_lang'].'" size="70" value="" />
					</div>';
				 }
				$this->_html .= $this->displayFlags($languages, $defaultLanguage, $divLangName, 'link_label', true);

        $this->_html .= '</div><p class="clear"> </p>
  			<label style="margin-top : -3px">'.$this->l('Link').'</label>
  			<div class="margin-form">
          <input type="text" name="link" value="" size="70" />
  			</div>
  			<div class="margin-form">
          <input type="checkbox" name="new_window" value="1" />&nbsp;'.$this->l('New Window').'
  			</div>
        <p class="center">
          <input type="submit" name="submitblockmenulavalampLinks" value="'.$this->l('  Add  ').'" class="button" />
        </p>
  		</form>
    </fieldset><br />';
    $this->_html .= '
    <fieldset>
      <legend><img src="../img/admin/details.gif" alt="" title="" />'.$this->l('List Menu Top Link').'</legend>
      <table style="width:100%;">
        <thead>
          <tr>
            <th>'.$this->l('Id Link').'</th>
            <th>'.$this->l('Label').'</th>
            <th>'.$this->l('Link').'</th>
            <th>'.$this->l('New Window').'</th>
            <th>'.$this->l('Action').'</th>
          </tr>
        </thead>
        <tbody>';
        $links = menulavalampLinks::gets($cookie->id_lang);
        foreach($links as $link)
        {
          $this->_html .= '
          <tr>
            <td>'.$link['id_link'].'</td>
            <td>'.$link['label'].'</td>
            <td>'.$link['link'].'</td>
            <td>'.(($link['new_window']) ? $this->l('Yes') : $this->l('No')).'</td>
            <td>
              <form action="'.$_SERVER['REQUEST_URI'].'" method="post">
                <input type="hidden" name="id_link" value="'.$link['id_link'].'" />
          			<input type="submit" name="submitblockmenulavalampRemove" value="'.$this->l('Remove').'" class="button" />
          		</form>
            </td>
          </tr>';
        }
        $this->_html .= '</tbody>
      </table>
  	</fieldset><br/>
  	<fieldset>
      <legend><img src="../img/admin/tab-customers.gif" />'.$this->l('Thanks').'</legend>
      <div>
        <a href="http://www.julien-breux.com/categorie/prestashop/prestashop-modules-gratuits/menuhorizontal/" target="_blank">'.$this->l('- Original module : Julien Breux').'</a>
  		</div>
  	</fieldset>';
	
    echo $this->_html;
  }
	
  private function getMenuItems()
  {
    $items = Configuration::get('MOD_BLOCKMENULAVALAMP_ITEMS');
    $items = explode(',', $items);
    return $items;
  }
  private function getMenuStyle2()
  {
  	$MenuStyleComplet = '<style>
		#searchbox_text {
			margin-top: 10px;
			font-size: 16px;
			-moz-border-radius: 5px 5px 5px 5px;
			background: url('.$this->_path.'images/loupe.gif) no-repeat left 2px;
			background-color:#FFFFFF;
			padding-left: 20px;
		}
		.lavalamp-contener {
		  clear: both;
		  margin: 10px 0;
		  height: 30px;
		  line-height: 30px;
		  padding-left: 7px;
		  padding-bottom: 30px;
		  background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_FOND').';
		}
        .lavaLampBottomStyle {
            position: relative;
            height: 29px;
            width: 940px;
            background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_FOND').';
            padding: 15px;
            margin: 10px 0 0 -9px;
            overflow: hidden;
            border: '.Configuration::get('MOD_BLOCKMENULAVALAMP_ENCADRE').'px solid gray;
        }	
        .lavaLampWithImage {
            position: relative;
            height: 29px;
            width: 940px;
            background: url('.$this->_path.'images/bg.gif) no-repeat top;
            padding: 15px;
            margin: 0px 0 0 -9px;
            overflow: hidden;
        }
                .lavaLampWithImage li {
                    float: left;
                    list-style: none;
                }
				 .lavaLampWithImage li.back {
                        background: url('.$this->_path.'images/lava.gif) no-repeat right -30px;
                        width: 9px; height: 30px;
                        z-index: 8;
                        position: absolute;
                    }
                        .lavaLampWithImage li.back .left {
                            background: url('.$this->_path.'images/lava.gif) no-repeat top left;
                            height: 30px;
                            margin-right: 9px;
                        }
					.lavaLampWithImage li a {
						font: '.Configuration::get('MOD_BLOCKMENULAVALAMP_POLICE').'px arial;
						color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_TEXTE').';
						outline: none;
						text-align: center;
						top: 7px;
						letter-spacing: 0;
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_GRAS'))=="on" ? ' font-weight:bold;': 'font-weight:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_ITALIC'))=="on" ? ' font-style:italic;': 'font-style:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SOULI'))=="on" ? ' text-decoration:underline;': 'text-decoration:none;').'
						z-index: 10;
						display: block;
						float: left;
						height: 30px;
						position: relative;
						overflow: hidden;
						margin: auto 10px;    
					}		
					.lavaLampWithImage li a:hover {
						color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_HOVER').';
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SGRAS'))=="on" ? ' font-weight:bold;': 'font-weight:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SITALIC'))=="on" ? ' font-style:italic;': 'font-style:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SSOULI'))=="on" ? ' text-decoration:underline;': 'text-decoration:none;').'
					}	
					.lavaLampNoImage li a:hover {
						color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_HOVER').';
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SGRAS'))=="on" ? ' font-weight:bold;': 'font-weight:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SITALIC'))=="on" ? ' font-style:italic;': 'font-style:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SSOULI'))=="on" ? ' text-decoration:underline;': 'text-decoration:none;').'
					}	
					.lavaLampBottomStyle li a:hover {
						color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_HOVER').';
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SGRAS'))=="on" ? ' font-weight:bold;': 'font-weight:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SITALIC'))=="on" ? ' font-style:italic;': 'font-style:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SSOULI'))=="on" ? ' text-decoration:underline;': 'text-decoration:none;').'
					}	
                        .lavaLampWithImage li a:hover, .lavaLampWithImage li a:active, .lavaLampWithImage li a:visited {
                            border: none;
                        }
		.lavaLampNoImage {
            position: relative;
            height: 29px;
            width: 940px;
            background-color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_FOND').';
            padding: 15px;
            margin: 0px 0 0 -9px;
            overflow: hidden;
            border: '.Configuration::get('MOD_BLOCKMENULAVALAMP_ENCADRE').'px solid gray;
        }
		.lavaLampBottomStyle li.back {
			border-bottom: 5px solid #'.Configuration::get('MOD_BLOCKMENULAVALAMP_COULEUR').';
			width: 9px;
			height: 30px;
			z-index: 8;
			position: absolute;
		}
				.lavaLampNoImage li {
                    float: left;
                    list-style: none;
                }
                    .lavaLampNoImage li.back {
                        border: 1px solid #000;
                        background-color: #e6e8ea;
                        width: 9px;
                        height: 30px;
                        z-index: 8;
                        position: absolute;
                    }
                    .lavaLampNoImage li a {
                        font: '.Configuration::get('MOD_BLOCKMENULAVALAMP_POLICE').'px arial;
                        color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_TEXTE').';
                        outline: none;
                        text-align: center;
                        top: 7px;
                        letter-spacing: 0;
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_GRAS'))=="on" ? ' font-weight:bold;': 'font-weight:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_ITALIC'))=="on" ? ' font-style:italic;': 'font-style:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SOULI'))=="on" ? ' text-decoration:underline;': 'text-decoration:none;').'
                        z-index: 10;
                        display: block;
                        float: left;
                        height: 30px;
                        position: relative;
                        overflow: hidden;
                        margin: auto 10px;
                    }
                        .lavaLampNoImage li a:hover, .lavaLampNoImage li a:active, .lavaLampNoImage li a:visited {
                            border: none;
                        }                    


                .lavaLampBottomStyle li {
                    float: left;
                    list-style: none;
                }
                    
                    .lavaLampBottomStyle li a {
                        font: '.Configuration::get('MOD_BLOCKMENULAVALAMP_POLICE').'px arial;
                        color: #'.Configuration::get('MOD_BLOCKMENULAVALAMP_TEXTE').';
                        outline: none;
                        text-align: center;
                        top: 7px;
                        letter-spacing: 0;
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_GRAS'))=="on" ? ' font-weight:bold;': 'font-weight:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_ITALIC'))=="on" ? ' font-style:italic;': 'font-style:normal;').'
						'.((Configuration::get('MOD_BLOCKMENULAVALAMP_SOULI'))=="on" ? ' text-decoration:underline;': 'text-decoration:none;').'
                        z-index: 10;
                        display: block;
                        float: left;
                        height: 30px;
                        position: relative;
                        overflow: hidden;
                        margin: auto 10px;
                    }   
                        .lavaLampBottomStyle li a:hover, .lavaLampBottomStyle li a:active, .lavaLampBottomStyle li a:visited {
                            border: none;
                        } 		
		</style>';
	return $MenuStyleComplet;
  }
  private function getMenuStyle()
  {
    $MenuStyle = Configuration::get('MOD_BLOCKMENULAVALAMP_STYLE');
	switch($MenuStyle) {
		case "1":
			$MenuStyleSelected = "lavaLampWithImage";
		break;
		case "2":
			$MenuStyleSelected = "lavaLampNoImage";
		break;
		case "3":
			$MenuStyleSelected = "lavaLampBottomStyle";
		break;				
	}
	return $MenuStyleSelected;
  }  
  private function makeMenuOption()
  {
    global $cookie;
    foreach($this->getMenuItems() as $item)
    {
      $id = (int)substr($item, 3, strlen($item));
      switch(substr($item, 0, 3))
      {
        case'CAT':
          $this->getCategoryOption($id, $cookie->id_lang, false);
        break;
        case'PRD':
          $product = new Product($id, true, $cookie->id_lang);
          if(!is_null($product->id))
            $this->_html .= '<option value="PRD'.$id.'">'.$product->name.'</option>'.PHP_EOL;
        break;
        case'CMS':
          $cms = CMS::getLinks($cookie->id_lang, array($id));
          if(count($cms))
            $this->_html .= '<option value="CMS'.$id.'">'.$cms[0]['meta_title'].'</option>'.PHP_EOL;
        break;
        case'MAN':
          $manufacturer = new Manufacturer($id, $cookie->id_lang);
          if(!is_null($manufacturer->id))
            $this->_html .= '<option value="MAN'.$id.'">'.$manufacturer->name.'</option>'.PHP_EOL;
        break;
        case'SUP':
          $supplier = new Supplier($id, $cookie->id_lang);
          if(!is_null($supplier->id))
            $this->_html .= '<option value="SUP'.$id.'">'.$supplier->name.'</option>'.PHP_EOL;
        break;
        case'LNK':
          $link = menulavalampLinks::get($id, $cookie->id_lang);
          if(count($link))
            $this->_html .= '<option value="LNK'.$id.'">'.$link[0]['label'].'</option>'.PHP_EOL;
        break;
      }
    }
  }

  private function makeMenu()
  {
	global $cookie, $page_name;
    foreach($this->getMenuItems() as $item)
    {
      $id = (int)substr($item, 3, strlen($item));
      switch(substr($item, 0, 3))
      {
        case'CAT':
          $this->getCategory($id, $cookie->id_lang);
        break;
        case'PRD':
          $selected = ($page_name == 'product' && (Tools::getValue('id_product') == $id)) ? ' class="current"' : '';
          $product = new Product($id, true, $cookie->id_lang);
          if(!is_null($product->id))
            $this->_menu .= '<li'.$selected.' style="float:left"><a href="'.$product->getLink().'">'.$product->name.'</a></li>'.PHP_EOL;
        break;
        case'CMS':
          $selected = ($page_name == 'cms' && (Tools::getValue('id_cms') == $id)) ? ' class="current"' : '';
          $cms = CMS::getLinks($cookie->id_lang, array($id));
          if(count($cms))
            $this->_menu .= '<li'.$selected.' style="float:left"><a href="'.$cms[0]['link'].'">'.$cms[0]['meta_title'].'</a></li>'.PHP_EOL;
        break;
        case'MAN':
          $selected = ($page_name == 'manufacturer' && (Tools::getValue('id_manufacturer') == $id)) ? ' class="current"' : '';
          $manufacturer = new Manufacturer($id, $cookie->id_lang);
          if(!is_null($manufacturer->id))
          {
      			if (intval(Configuration::get('PS_REWRITING_SETTINGS')))
      				$manufacturer->link_rewrite = Tools::link_rewrite($manufacturer->name, false);
      			else
      				$manufacturer->link_rewrite = 0;
      			$link = new Link;
            $this->_menu .= '<li'.$selected.' style="float:left"><a href="'.$link->getManufacturerLink($id, $manufacturer->link_rewrite).'">'.$manufacturer->name.'</a></li>'.PHP_EOL;
          }
        break;
        case'SUP':
          $selected = ($page_name == 'supplier' && (Tools::getValue('id_supplier') == $id)) ? ' class="current"' : '';
          $supplier = new Supplier($id, $cookie->id_lang);
          if(!is_null($supplier->id))
          {
            $link = new Link;
            $this->_menu .= '<li'.$selected.' style="float:left"><a href="'.$link->getSupplierLink($id, $supplier->link_rewrite).'">'.$supplier->name.'</a></li>'.PHP_EOL;
          }
        break;
        case'LNK':
          $link = menulavalampLinks::get($id, $cookie->id_lang);
          if(count($link))
            $this->_menu .= '<li style="float:left"><a href="'.$link[0]['link'].'"'.(($link[0]['new_window']) ? ' target="_blank"': '').'>'.$link[0]['label'].'</a></li>'.PHP_EOL;
        break;
      }
    }
  }

  private function getCategoryOption($id_category, $id_lang, $children = true)
  {
    $categorie = new Category($id_category, $id_lang);
    if(is_null($categorie->id))
      return;
    if(count(explode('.', $categorie->name)) > 1)
      $name = str_replace('.', '', strstr($categorie->name, '.'));
    else
      $name = $categorie->name;
    $this->_html .= '<option value="CAT'.$categorie->id.'" style="margin-left:'.(($children) ? round(15+(15*(int)$categorie->level_depth)) : 0).'px;">'.$name.'</option>';
    if($children)
    {
      $childrens = Category::getChildren($id_category, $id_lang);
      if(count($childrens))
        foreach($childrens as $children)
          $this->getCategoryOption($children['id_category'], $id_lang);
    }
  }

  private function getCategory($id_category, $id_lang)
  {
    global $page_name;

    $categorie = new Category($id_category, $id_lang);
    if(is_null($categorie->id))
      return;
    $selected = ($page_name == 'category' && ((int)Tools::getValue('id_category') == $id_category)) ? ' class="current"' : '';
    $this->_menu .= '<li'.$selected.' style="float:left">';
    if(count(explode('.', $categorie->name)) > 1)
      $name = str_replace('.', '', strstr($categorie->name, '.'));
    else
      $name = $categorie->name;
    $this->_menu .= '<a href="'.$categorie->getLink().'">'.$name.'</a>';
   /* 
   	$childrens = Category::getChildren($id_category, $id_lang);
    if(count($childrens))
    {
      $this->_menu .= '<ul>';
      foreach($childrens as $children)
        $this->getCategory($children['id_category'], $id_lang);
      $this->_menu .= '</ul>';
    }*/
    $this->_menu .= '</li>';
  }
  public function hooktop($param)
  {
	    $this->_style = $this->getMenuStyle();
		$this->_style2 = $this->getMenuStyle2();
		global $smarty;
		$this->makeMenu();
		$languages = Language::getLanguages();
		if (!sizeof($languages))
			return '';
		$smarty->assign('languages', $languages);
		$smarty->assign('MENU_LAVALAMP_SEARCH', Configuration::get('MOD_BLOCKMENULAVALAMP_SEARCH'));
		$smarty->assign('BLOCKLANG', Configuration::get('MOD_BLOCKMENULAVALAMP_LANG'));
		$smarty->assign('MENU_LAVALAMP', $this->_menu);
		$smarty->assign('MENU_STYLE', $this->_style);
		$smarty->assign('MENU_STYLE2', $this->_style2);
		$smarty->assign('this_path', $this->_path);
    return $this->display(__FILE__, 'blockmenulavalamp.tpl');
  }
}
?>